/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "network/network.h"

#define LISTENQ		5
#define SERV_PORT	7876

int main(void)
{
	fe::UnitTest unitTest;

	try
	{

		fe::sp<fe::Socket>		connection(new fe::Socket);
		fe::SockAddr			server_addr;

		server_addr.setPort(SERV_PORT);
		server_addr.setAddress("127.0.0.1");

		connection->openStream();
		connection->connect(server_addr);

		fe::sp<fe::ChunkSpool> spBuffer(new fe::ChunkSpool);

		fe::sp<fe::ChunkReceiver> spReceiver(new fe::ChunkReceiver);

		spReceiver->start(spBuffer, connection);

		while(true)
		{
			fe::sp<fe::Chunk> spChunk;
			spChunk = spBuffer->wait();
			feLogGroup("network","received chunk of size %u\n", spChunk->size());
		}

		spReceiver->stop();

	}
	catch(fe::Exception &e)
	{
		e.log();
	}

	return unitTest.failures();
}


